<template>
	<div>
		<div class="container job-search-container">
			<div class="row justify-content-center">
				<h1 class="text-white font-weight-bold">
					<span style="color: #42b883">FILL</span> CV FORM
				</h1 class="text-white">
			</div>
		</div>
		<div class="container">
			<div class="row justify-content-center">
				<div class="col-10 col-sm-12 col-md-12 col-lg-10 col-md-10 job-form-box mb-4">
					<el-steps class="mt-5 my-5" :active="active" finish-status="success">
					  	<el-step title="Step 1"></el-step>
					  	<el-step title="Step 2"></el-step>
					  	<el-step title="Step 3"></el-step>
					</el-steps>

					<el-form :model="cvForm" ref="cvForm" :rules="rules" :label-position="'top'" label-width="100px" class="mt-5 cv-form">
					  	<span v-if="active===1">
					  		<el-form-item label="Full Name" prop="name">
						    	<el-input v-model="cvForm.name" placeholder="Write your full name">
						    		{{ cvForm.name }}
						    	</el-input>
						  	</el-form-item>
						  	<el-form-item label="Email" prop="email">
						    	<el-input type="email" v-model="cvForm.email" placeholder="Write your email">
						    		{{ cvForm.email }}
						    	</el-input>
						  	</el-form-item>
						  	<el-form-item label="Date of Birth" prop="birth">
						    	<el-date-picker
							  	    v-model="cvForm.birth"
							  	    type="date"
							  	    placeholder="Pick your birth date">
							  	    {{ cvForm.birth }}
							  	</el-date-picker>
						  	</el-form-item>
					  	</span>
					  	<span v-if="active===2">
						  	<el-form-item label="NRC no" prop="nrc_no">
						    	<el-input v-model="cvForm.nrc_no" placeholder="Write your nrc no">
						    		{{ cvForm.nrc_no }}
						    	</el-input>
						  	</el-form-item>
					  		<el-form-item label="Certificate and Degree (if any)" prop="certificate">
						    	<el-input v-model="cvForm.certificate" placeholder="Write your certificate">
						    		{{ cvForm.certificate }}
						    	</el-input>
						  	</el-form-item>
						  	<el-form-item label="Attending University (Subject & Year)" prop="university">
						    	<el-input v-model="cvForm.university" placeholder="Write your university">
						    		{{ cvForm.university }}
						    	</el-input>
						  	</el-form-item>
					  	</span>
					  	<span v-if="active===3">
						  	<el-form-item label="Occupation" prop="occupation">
						    	<el-input v-model="cvForm.occupation" placeholder="Write your occupation">
						    		{{ cvForm.occupation }}
						    	</el-input>
						  	</el-form-item>
						  	<el-form-item label="Address" prop="address">
						    	<el-input v-model="cvForm.address" placeholder="Write your address">
						    		{{ cvForm.address }}
						    	</el-input>
						  	</el-form-item>
					  		<el-form-item label="Telephone No:" prop="telephone">
						    	<el-input type="number" v-model="cvForm.telephone" placeholder="Write your telephone">
						    		{{ cvForm.telephone }}
						    	</el-input>
						  	</el-form-item>
					  	</span>
						<el-button type="default" @click="previous" v-if="active > 1">
							<i class="el-icon-caret-left"></i> Previous 
						</el-button>
						<el-button type="default" @click="next" class="float-right" v-if="active!=3">
							Next <i class="el-icon-caret-right"></i>
						</el-button>
						<el-button @click="updateModal()" class="float-right btn btn-save" v-if="active===3">
							Update
						</el-button>
					</el-form>

				</div>
			</div>
		</div>
	</div>
</template>

<script>
  	export default {
	    data() {
	      	return {
	      		id: this.$route.params.id,
	        	active: 1,
	        	cvForm: {
	        		name: '',
	        		email: '',
	        		birth: '',
	        		nrc_no: '',
	        		certificate: '',
	        		university: '',
	        		occupation: '',
	        		address: '',
	        		telephone: '',
	        	},
	        	rules: {
		        	name: [
		            	{ required: true, message: 'Please input your name', trigger: 'blur' }
		          	],
		          	email: [
                        { required: true, message: 'Please input email address', trigger: ['blur', 'change'] },
                        { type: 'email', message: 'Please input correct email address', trigger: ['blur', 'change'] }
                    ],
		          	birth: [
		            	{ required: true, message: 'Please input your date of birth', trigger: 'blur' }
		          	],
		          	nrc_no: [
		            	{ required: true, message: 'Please input your nrc no', trigger: 'blur' }
		          	],
		          	address: [
		            	{ required: true, message: 'Please input your address', trigger: 'blur' }
		          	],
		          	telephone: [
		            	{ required: true, message: 'Please input your telephone number', trigger: 'blur' }
		          	],
		        }
	      	};
	    },
	    mounted() {

			axios.get('/cvform/' + this.id +'/edit')
			.then(response => {
				this.cvForm.name = response.data.name;
				this.cvForm.email = response.data.email;
				this.cvForm.birth = response.data.birth;
				this.cvForm.nrc_no = response.data.nrc_no;
				this.cvForm.certificate = response.data.certificate;
				this.cvForm.university = response.data.university;
				this.cvForm.occupation = response.data.occupation;
				this.cvForm.address = response.data.address;
				this.cvForm.telephone = response.data.telephone;
			});
		},
	    methods: {
	      	next() {
	        	if (this.active++ > 2) this.active = 1;
	      	},
	      	previous() {
	        	this.active--;
	      	},
			updateCvform() {
				axios.patch('/cvform/' + this.id,{
					name: this.cvForm.name,
					email: this.cvForm.email,
					birth: this.cvForm.birth,
					nrc_no: this.cvForm.nrc_no,
					certificate: this.cvForm.certificate,
					university: this.cvForm.university,
					occupation: this.cvForm.occupation,
					address: this.cvForm.address,
					telephone: this.cvForm.telephone,
				})
				.then(response => this.$router.replace({ name: 'HowItWork'}))
			},
			updateModal() {
				this.$confirm('Do you want to update?', 'Confirm', {
	         	distinguishCancelAndClose: true,
	         	confirmButtonText: 'Confirm',
	         	cancelButtonText: 'Discard Changes'
	       		})
	         	.then(() => {
		           	this.$message({
		             	type: 'success',
		             	message: 'Changes saved.',
		             	option: this.updateCvform()
		           	});
	         	})
	         	.catch(action => {
	           		this.$message({
	             	type: 'info',
	             	message: action === 'cancel'
	               	? 'Changes discarded. Proceeding to a new route.'
	               	: 'Stay in the current route'
	           		})
				})
			}
	    }
  	}
</script>